diff --git a/src/web100srv.h b/src/web100srv.h
index a48c7bb..d797e0f 100644
--- a/src/web100srv.h
+++ b/src/web100srv.h
@@ -19,6 +19,9 @@
 #ifdef HAVE_LIBWEB100
 #include  <web100.h>
 #endif
+#ifdef HAVE_LIBTCPE
+#include <tcpe.h>
+#endif
 #ifdef HAVE_LIBPCAP
 #include  <pcap.h>
 #endif
@@ -190,6 +193,53 @@ struct iflists {
   u_int16_t speed[32];
 } iflist;
 
+typedef int tcp_stat_var;
+
+struct tcp_vars {
+  tcp_stat_var Timeouts;
+  tcp_stat_var SumRTT;
+  tcp_stat_var CountRTT;
+  tcp_stat_var PktsRetrans;
+  tcp_stat_var FastRetran;
+  tcp_stat_var DataPktsOut;
+  tcp_stat_var AckPktsOut;
+  tcp_stat_var CurrentMSS;
+  tcp_stat_var DupAcksIn;
+  tcp_stat_var AckPktsIn;
+  tcp_stat_var MaxRwinRcvd;
+  tcp_stat_var Sndbuf;
+  tcp_stat_var CurrentCwnd;
+  tcp_stat_var SndLimTimeRwin;
+  tcp_stat_var SndLimTimeCwnd;
+  tcp_stat_var SndLimTimeSender;
+  tcp_stat_var DataBytesOut;
+  tcp_stat_var SndLimTransRwin;
+  tcp_stat_var SndLimTransCwnd;
+  tcp_stat_var SndLimTransSender;
+  tcp_stat_var MaxSsthresh;
+  tcp_stat_var CurrentRTO;
+  tcp_stat_var CurrentRwinRcvd;
+  tcp_stat_var MaxCwnd;
+  tcp_stat_var CongestionSignals;
+  tcp_stat_var PktsOut;
+  tcp_stat_var MinRTT;
+  tcp_stat_var RcvWinScale;
+  tcp_stat_var SndWinScale;
+  tcp_stat_var CongAvoid;
+  tcp_stat_var CongestionOverCount;
+  tcp_stat_var MaxRTT;
+  tcp_stat_var OtherReductions;
+  tcp_stat_var CurTimeoutCount;
+  tcp_stat_var AbruptTimeouts;
+  tcp_stat_var SendStall;
+  tcp_stat_var SlowStart;
+  tcp_stat_var SubsequentTimeouts;
+  tcp_stat_var ThruBytesAcked;
+  /* Additional for web10g */
+  tcp_stat_var MaxSsCwnd;
+  tcp_stat_var MaxCaCwnd;
+};
+
 /* web100-pcap */
 #ifdef HAVE_LIBPCAP
 void init_vars(struct spdpair *cur);
@@ -198,40 +248,78 @@ void calculate_spd(struct spdpair *cur, struct spdpair *cur2, int port2,
                    int port3);
 void init_pkttrace(I2Addr srcAddr, struct sockaddr *sock_addr,
                    socklen_t saddrlen, int monitor_pipe[2], char *device,
-                   PortPair* pair, char * direction, int compress);
-int check_signal_flags();
+                   PortPair* pair, const char * direction, int compress);
+void force_breakloop();
 #endif
 
 /* web100-util */
-#ifdef HAVE_LIBWEB100
+#if defined(HAVE_LIBWEB100)
+#if (!defined(HAVE_LIBTCPE) || defined(FORCE_WEB100))
+#define USE_WEB100 true
+#define USE_TCPE false
+#else
+#define USE_WEB100 false
+#define USE_TCPE true
+#endif
+#elif defined(HAVE_LIBTCPE)
+#define USE_WEB100 false
+#define USE_TCPE true
+#else
+#error Either Web100 or Web10g must be available
+#define USE_WEB100 false
+#define USE_TCPE false
+#endif
+
+#if USE_WEB100 || USE_TCPE
 void get_iflist(void);
-int web100_init(char *VarFileName);
-int web100_autotune(int sock, web100_agent* agent, web100_connection* cn);
-void web100_middlebox(int sock, web100_agent* agent, web100_connection* cn,
+
+#if USE_TCPE
+typedef struct tcpe_client tcp_stat_agent;
+typedef int tcp_stat_connection;
+typedef struct tcpe_data tcp_stat_snap;
+/* Not relevent to web10g */
+typedef void tcp_stat_group;
+/* Log currently unimplemented in web100 */
+typedef void tcp_stat_log;
+#define tcp_stat_connection_from_socket web10g_connection_from_socket
+
+/* Extra Web10G functions web10g-util.c */
+int web10g_find_val(tcpe_data* data, char* name, struct tcpe_val* value);
+int web10g_get_val(struct tcpe_client* client, int conn, char* name, struct tcpe_val * value);
+int web10g_connection_from_socket(struct tcpe_client* client,int sockfd);
+int web10g_get_remote_addr(struct tcpe_client* client, int conn, char* out, int size);
+
+#elif USE_WEB100
+
+typedef web100_agent tcp_stat_agent;
+typedef web100_connection* tcp_stat_connection;
+typedef web100_snapshot tcp_stat_snap;
+/* Group only relevent to web100 */
+typedef web100_group tcp_stat_group;
+/* Log currently unimplemented in web100 */
+typedef web100_log tcp_stat_log;
+#define tcp_stat_connection_from_socket web100_connection_from_socket
+
+#endif
+
+int tcp_stat_autotune(int sock, tcp_stat_agent* agent, tcp_stat_connection cn);
+int tcp_stat_init(char *VarFileName);
+void tcp_stat_middlebox(int sock, tcp_stat_agent* agent, tcp_stat_connection cn,
                       char *results, size_t results_strlen);
-int web100_setbuff(int sock, web100_agent* agent, web100_connection* cn,
-                   int autotune);
-void web100_get_data_recv(int sock, web100_agent* agent, web100_connection* cn,
+int tcp_stat_setbuff(int sock, tcp_stat_agent* agent, tcp_stat_connection cn,
+                   int autotune);/* Not used so no web10g version */
+void tcp_stat_get_data_recv(int sock, tcp_stat_agent* agent, tcp_stat_connection cn,
                           int count_vars);
-int web100_get_data(web100_snapshot* snap, int ctlsock, web100_agent* agent,
+int tcp_stat_get_data(tcp_stat_snap* snap, int testsock, int ctlsock, tcp_stat_agent* agent,
                     int count_vars);
-int CwndDecrease(web100_agent* agent, char* logname,
+
+// TODO web10g version of CwndDecrease
+int CwndDecrease(tcp_stat_agent* agent, char* logname,
                  u_int32_t *dec_cnt, u_int32_t *same_cnt, u_int32_t *inc_cnt);
-int web100_logvars(int *Timeouts, int *SumRTT, int *CountRTT,
-                   int *PktsRetrans, int *FastRetran, int *DataPktsOut,
-                   int *AckPktsOut, int *CurrentMSS, int *DupAcksIn,
-                   int *AckPktsIn, int *MaxRwinRcvd, int *Sndbuf,
-                   int *CurrentCwnd, int *SndLimTimeRwin, int *SndLimTimeCwnd,
-                   int *SndLimTimeSender, int *DataBytesOut,
-                   int *SndLimTransRwin, int *SndLimTransCwnd,
-                   int *SndLimTransSender, int *MaxSsthresh, int *CurrentRTO,
-                   int *CurrentRwinRcvd, int *MaxCwnd, int *CongestionSignals,
-                   int *PktsOut, int *MinRTT, int count_vars, int *RcvWinScale,
-                   int *SndWinScale, int *CongAvoid, int *CongestionOverCount,
-                   int *MaxRTT, int *OtherReductions, int *CurTimeoutCount,
-                   int *AbruptTimeouts, int *SendStall, int *SlowStart,
-                   int *SubsequentTimeouts, int *ThruBytesAcked);
-#endif
+int tcp_stat_logvars(struct tcp_vars* vars, int count_vars);
+
+#endif  // defined(HAVE_LIBWEB100) || defined(HAVE_LIBTCPE)
+
 int KillHung(void);
 void writeMeta(int compress, int cputime, int snaplog, int tcpdump);
 
diff --git a/src/web10g-util.c b/src/web10g-util.c
new file mode 100644
index 0000000..50e0622
--- /dev/null
+++ b/src/web10g-util.c
@@ -0,0 +1,227 @@
+/*
+ * A handful of functions to handle some web10g specific stuff
+ *
+ * Author: Richard Sanger
+ *
+ */
+
+/*
+ * These are used to pass information between web10g_connection_from_socket
+ * and getremote_callback. It would be nice if these were not globals.
+ */
+#include "web100srv.h"
+#include "logging.h"
+
+static struct sockaddr_storage local_name;
+static struct sockaddr_storage peer_name;
+static int connection_id;
+
+/**
+ * Callback function used by web10g_connection_from_socket, will set
+ * connection_id if the correct connection is found.
+ *
+ * @param ct A tuple containing connection information
+ */
+static void fromsocket_callback(struct tcpe_connection_tuple* ct) {
+  /* I'm assuming local_name and remote_name should both be on
+   * the same addressing scheme i.e. either IPv4 or IPv6 not a mix of both */
+  if(local_name.ss_family == AF_INET && peer_name.ss_family == AF_INET) {
+    /* We are IPv4 check if this web10g connection also is */
+    if ((ct->local_addr[16]) == TCPE_ADDRTYPE_IPV4 &&
+        (ct->rem_addr[16]) == TCPE_ADDRTYPE_IPV4) {
+      struct sockaddr_in * ipv4_local = (struct sockaddr_in *) &local_name;
+      struct sockaddr_in * ipv4_peer = (struct sockaddr_in *) &peer_name;
+
+      /* Compare local and remote ports and addresses */
+      if (ct->local_port == ntohs(ipv4_local->sin_port) &&
+          ct->rem_port == ntohs(ipv4_peer->sin_port) &&
+          ((struct in_addr*) ct->rem_addr)->s_addr == ipv4_peer->sin_addr.s_addr &&
+          ((struct in_addr*) ct->local_addr)->s_addr == ipv4_local->sin_addr.s_addr ) {
+        /* Found it */
+        connection_id = ct->cid;
+        log_println(2, "Matched socket to web10g IPv4 connection #%d", connection_id);
+      }
+    }
+  } else if(local_name.ss_family == AF_INET6 && peer_name.ss_family == AF_INET6) {
+    /* We are IPv6 check if this web10g connection also is */
+    if ((ct->local_addr[16]) == TCPE_ADDRTYPE_IPV6 &&
+        (ct->rem_addr[16]) == TCPE_ADDRTYPE_IPV6) {
+      struct sockaddr_in6 * ipv6_local = (struct sockaddr_in6 *) &local_name;
+      struct sockaddr_in6 * ipv6_peer = (struct sockaddr_in6 *) &peer_name;
+
+      /* Compare local and remote ports and addresses */
+      if (ct->local_port == ntohs(ipv6_local->sin6_port) &&
+          ct->rem_port == ntohs(ipv6_peer->sin6_port) &&
+          memcmp(ct->rem_addr, ipv6_peer->sin6_addr.s6_addr, sizeof(struct in6_addr)) == 0 &&
+          memcmp(ct->local_addr, ipv6_local->sin6_addr.s6_addr, sizeof(struct in6_addr)) == 0) {
+        /* Found it */
+        connection_id = ct->cid;
+        log_println(2, "Matched socket to web10g IPv6 connection #%d", connection_id);
+      }
+    }
+  } else {
+    log_println(1, "WARNING: Mismatch between local and peer family");
+  }
+}
+
+/**
+ * Find the web10g connection number related to a given socket.
+ *
+ * @param client A web10g client
+ * @param sockfd The socket file descriptor
+ *
+ * @return The connection number if successful. If an error occurs -1
+ * will be returned.
+ *
+ */
+int web10g_connection_from_socket(struct tcpe_client* client, int sockfd) {
+  socklen_t local_name_len;
+  socklen_t peer_name_len;
+
+  local_name_len = sizeof(local_name);
+  peer_name_len = sizeof(peer_name);
+  connection_id = -1;
+
+  /* Get the ip address of ourself on the localsocket */
+  if (getsockname(sockfd,(struct sockaddr *) &local_name, &local_name_len) == -1) {
+    log_println(1, "getsockname() failed: %s ", strerror(errno));
+    return -1;
+  }
+
+  /* Get the ip address of our peer */
+  if (getpeername(sockfd,(struct sockaddr *) &peer_name, &peer_name_len) == -1) {
+    log_println(1, "getpeername() failed: %s ", strerror(errno));
+    return -1;
+  }
+
+  tcpe_list_conns(client, fromsocket_callback);
+
+  return connection_id;
+}
+
+/**
+ * Find the specified web10g variable given a connection at the current
+ * time.
+ * Similar to web10g_find_val except this also retrieves data from web10g
+ * rather than from a provided capture. If many varibles are being read
+ * it's probably best to capture the data then use web10g_find_val.
+ *
+ * @param data A web10g data capture
+ * @param name The web10g variable name
+ * @param *value A pointer to a web10g value structure. If successful
+ *  this will contain the requested value upon return. If an error occurs
+ *  it's contents will remain untouched.
+ *
+ * @return int 0 if successful otherwise 1 in the event of an error
+ * (including the case the specified value cannot be found).
+ *
+ */
+int web10g_get_val(struct tcpe_client* client, int conn, char* name, struct tcpe_val* value) {
+  int i;
+  tcpe_data* data = NULL;
+
+  tcpe_data_new(&data);
+  tcpe_read_vars(data, conn, client);
+
+  for (i = 0; i < ARRAYSIZE(data->val); i++) {
+    if (data->val[i].mask) continue;
+
+    if (strcmp(tcpe_var_array[i].name, name) == 0){
+            value->uv64 = data->val[i].uv64;
+      value->mask = data->val[i].mask;
+      i = -1;
+      break;
+    }
+  }
+
+  tcpe_data_free(&data);
+  return i == -1 ? 1 : 0;
+}
+
+/*
+ * These are used to pass information between web10g_get_remote_addr
+ * and getremotecallback. It would be nice if these were not globals.
+ */
+static int connid;
+static char * remote_name;
+static int remote_name_size;
+
+/**
+ * Callback function used by web10g_get_remote_addr, will fill in
+ * remote_name once if the correct connection is found and set remote_name
+ * to NULL to indicate to web10g_get_remote_addr that the connection was
+ * found.
+ *
+ * @param ct A tuple containing connection information
+ *
+ */
+static void getremote_callback(struct tcpe_connection_tuple* ct) {
+  if (ct->cid != connid)
+    return;
+  if (ct->local_addr[16] == TCPE_ADDRTYPE_IPV4) {
+    inet_ntop(AF_INET, &(ct->rem_addr[0]), remote_name, remote_name_size);
+    remote_name = NULL;
+  } else if (ct->local_addr[16] == TCPE_ADDRTYPE_IPV6) {
+    inet_ntop(AF_INET6, &(ct->rem_addr[0]), remote_name, remote_name_size);
+    remote_name = NULL;
+  }
+}
+
+/**
+ * Get the remote address given connection number
+ *
+ * @param client Web10g client
+ * @param conn The web10g connection number
+ * @param out A pointer to a character buffer, into which the remote
+ *  address will be returned if successful. Upon error the contents are
+ *  remain unchanged.
+ * @param size The size of the buffer 'out'.
+ *
+ * @return int 0 if successful otherwise 1 in the event of an error
+ * (The connection could not be found).
+ *
+ */
+int web10g_get_remote_addr(struct tcpe_client* client, int conn, char* out, int size) {
+  /* Pass these to the callback routine using those globals */
+  connid = conn;
+  remote_name = out;
+  remote_name_size = size;
+  /* This will call the getremote_callback once for every tcp connection */
+  tcpe_list_conns(client, getremote_callback);
+
+  return remote_name == NULL ? 0 : 1;
+}
+
+/**
+ * Find the specified web10g variables value within a provided capture.
+ * Similar to web10g_get_val except this works on a previously retrieved
+ * set of data.
+ *
+ * @param data A web10g data capture
+ * @param name The web10g variable name
+ * @param *value A pointer to a web10g value structure. If successful
+ *  this will contain the requested value upon return. If an error occurs
+ *  its contents will remain untouched.
+ *
+ * @return int 0 if successful otherwise 1 in the event of an error
+ * (including the case the specified value cannot be found).
+ *
+ */
+int web10g_find_val(tcpe_data* data, char* name, struct tcpe_val* value) {
+  int i;
+
+  if(data == NULL || name == NULL || value == NULL)
+    return 1;
+
+  for (i = 0; i < ARRAYSIZE(data->val); i++) {
+    if (data->val[i].mask) continue;
+    if (strcmp(tcpe_var_array[i].name, name) == 0){
+      value->uv64 = data->val[i].uv64;
+      value->mask = data->val[i].mask;
+      return 0;
+    }
+  }
+
+  return 1;
+}
+
